; //-----------------------------------------------------------\\ ;
; \\-----------------------------------------------------------// ;
; //---                 Damol Software                      ---\\ ;
; \\-----------------------------------------------------------// ;
; //---                   Dolparam.asm                      ---\\ ;
; \\---                                                     ---// ;
; //---         Configure utility for Dolmsgpw              ---\\ ;
; \\---                                                     ---// ;
; //-----------------------------------------------------------\\ ;
; \\--- Written by maDLess dam.zeugma@wanadoo.fr            ---// ;
; \\-----------------------------------------------------------// ;
; //--- the Damol Software Web Site :                       ---\\ ;
; \\---            http://damol.8m.com/                     ---// ;
; //-----------------------------------------------------------\\ ;
; \\-----------------------------------------------------------// ;

 include "tios.h"
 include "util.h"
 include "dolmsgpw.inc"

 xdef _main
 xdef _ti89

; //-----------------------------------------------------------\\ ;
; \\-----------------------------------------------------------// ;
; // void Put_str ( char *String, int x, int y, int color );
; // Famous one
; //-----------------------------------------------------------\\ ;
; \\-----------------------------------------------------------// ;

Put_str MACRO
 move.w   \4,-(a7)
 pea      \1
 move.w   \3,-(a7)
 move.w   \2,-(a7)
 jsr      tios::DrawStrXY
 adda.l   #10,a7
 ENDM

; //-----------------------------------------------------------\\ ;
; \\-----------------------------------------------------------// ;
; // void Get_str ( char *String, int x, int y, int num_char );
; // Quite spread one too
; //-----------------------------------------------------------\\ ;
; \\-----------------------------------------------------------// ;

Get_str MACRO
        move.w \2,d5
        move.w \3,d6
        move.w \4-1,d7
        move.w d7,d4
        move.l #\1,a5
        bsr take_string
        ENDM

_main:

first
 jsr      util::zap_screen
 Put_str  menu,#10,#20,#4
 Put_str  changemsg,#10,#35,#4   
 Put_str  changepwd,#10,#50,#4
 Put_str  exit,#10,#65,#4 

debut
 jsr      util::idle_loop
 cmp.w    #49,d0                ; "1" or "q" (if alpha is pressed) selected -> change the msg
 beq      msg                   ; 
 cmp.w    #113,d0               ; 
 beq      msg                   ; 
 cmp.w    #51,d0                ; "3" or "s" (if alpha is pressed) pressed -> exit
 beq      bye                   ; 
 cmp.w    #115,d0               ; 
 beq      bye                   ; 
 cmp.w    #50,d0                ; "2" or "r" (if alpha is pressed) pressed -> change the pwd
 beq      pwd                   ; 
 cmp.w    #114,d0               ; 
 beq      pwd                   ;
 bra      debut                 ; other key pressed -> scan the keyboard again
                                ;
bye                             ;
 rts                            ;
                                ;
pwd                             ; 
 jsr      util::zap_screen      ;
 Put_str  oldpass,#10,#40,#4    ; ask for the old pwd
 Get_str  string,#72,#40,#10    ;
 pea      dolmsgpw::sto_pass    ; compare 'string'=what u've entered with the real password
 pea      string                ;
 jsr      tios::strcmp          ;
 adda.l   #8,a7                 ; 
 cmp.w    #0,d0                 ; if 'string'='sto_pass' -> go to the new pass prompt
 beq      enter_new_pass        ;
 rts                            ; else : someone may try to change your password !!!
                                ; bye
enter_new_pass                  ;
 jsr      util::zap_screen      ;
 Put_str  newpass,#10,#40,#4    ; ask for the new pwd
 Get_str  string,#72,#40,#10    ; put it in string
 Put_str  confirm,#10,#55,#4    ; reask the new password 
 Get_str  string2,#72,#55,#10   ; put it in string2
 pea      string                ; 
 pea      string2               ; 
 jsr      tios::strcmp          ; compare string and string2
 adda.l   #8,a7                 ; restore the stack
 cmp.w    #0,d0                 ; if 'string'='string2'
 beq      change_it             ; goto change_it
 jsr      util::zap_screen      ; else 
 Put_str  notchanged,#10,#40,#4 ; the password is NOT changed                   
 jsr      util::idle_loop       ; wait for a key press
 bra      first                 ;
change_it                       ;
 move.l   #10,-(a7)             ; copy the first 10 char
 pea      string                ; from string
 pea      dolmsgpw::sto_pass    ; to dolmsgpw::sto_pass
 jsr      tios::strncpy         ;
 adda.l   #12,a7                ;
 jsr      util::zap_screen      ;  
 Put_str  changed,#7,#40,#4     ; the password is changed    
 jsr      util::idle_loop       ; wait for a key press       
 bra      first                 ;

msg                             ; begining of the msg config
 jsr      util::zap_screen      ; section
 Put_str  msgstr,#10,#20,#4
 Put_str  ermsg,#10,#35,#4   
 Put_str  chmsg,#10,#50,#4
 Put_str  vimsg,#10,#65,#4 
 Put_str  return,#10,#80,#4
 
debut2
 jsr      util::idle_loop
 cmp.w    #49,d0                ; "1" or "q" (if alpha is pressed) selected -> erase the msg
 beq      era                   ; 
 cmp.w    #113,d0               ; 
 beq      era                   ; 
 cmp.w    #51,d0                ; "3" or "s" (if alpha is pressed) pressed -> view the msg
 beq      vi                    ; 
 cmp.w    #115,d0               ; 
 beq      vi                    ; 
 cmp.w    #50,d0                ; "2" or "r" (if alpha is pressed) pressed -> change the msg
 beq      change_message        ; 
 cmp.w    #114,d0               ; 
 beq      change_message        ;
 cmp.w    #52,d0                ; handles the return to the main screen
 beq      first 
 cmp.w    #52,d0
 beq      first
 cmp.w    #108,d0
 beq      first   
 bra      debut2                ; other key pressed -> scan the keyboard again

vi
 jsr      util::zap_screen 
 Put_str  dolmsgpw::line0,#0,#0,#4
 Put_str  dolmsgpw::line1,#0,#10,#4
 Put_str  dolmsgpw::line2,#0,#20,#4
 Put_str  dolmsgpw::line3,#0,#30,#4
 Put_str  dolmsgpw::line4,#0,#40,#4
 Put_str  dolmsgpw::line5,#0,#50,#4
 Put_str  dolmsgpw::line6,#0,#60,#4
 Put_str  dolmsgpw::line7,#0,#70,#4
 Put_str  dolmsgpw::line8,#0,#80,#4
 jsr      util::idle_loop
 bra      msg

era
 jsr      util::zap_screen
 move.l   #26,-(a7) 
 pea      freeline              ; from freeline
 pea      dolmsgpw::line0       ; to dolmsgpw::line*
 jsr      tios::strncpy         ;
 adda.l   #12,a7                ;
 move.l   #26,-(a7)
 pea      freeline            
 pea      dolmsgpw::line1  
 jsr      tios::strncpy  
 adda.l   #12,a7
 move.l   #26,-(a7)
 pea      freeline            
 pea      dolmsgpw::line2   
 jsr      tios::strncpy  
 adda.l   #12,a7         
 move.l   #26,-(a7)
 pea      freeline            
 pea      dolmsgpw::line3   
 jsr      tios::strncpy  
 adda.l   #12,a7   
 move.l   #26,-(a7)
 pea      freeline            
 pea      dolmsgpw::line4   
 jsr      tios::strncpy  
 adda.l   #12,a7 
 move.l   #26,-(a7)
 pea      freeline            
 pea      dolmsgpw::line5   
 jsr      tios::strncpy  
 adda.l   #12,a7 
 move.l   #26,-(a7)
 pea      freeline            
 pea      dolmsgpw::line6   
 jsr      tios::strncpy  
 adda.l   #12,a7 
 move.l   #26,-(a7)
 pea      freeline            
 pea      dolmsgpw::line7   
 jsr      tios::strncpy  
 adda.l   #12,a7 
 move.l   #26,-(a7)
 pea      freeline            
 pea      dolmsgpw::line8   
 jsr      tios::strncpy  
 adda.l   #12,a7 
 Put_str  done,#10,#40,#4
 jsr      util::idle_loop
 bra      msg 

change_message
 move.b   #1,try
 jsr      util::zap_screen
 Put_str  strline1,#0,#90,#4
 Get_str  dolmsgpw::line0,#0,#0,#26
 Put_str  strline2,#0,#90,#4
 Get_str  dolmsgpw::line1,#0,#10,#26  
 Put_str  strline3,#0,#90,#4
 Get_str  dolmsgpw::line2,#0,#20,#26
 Put_str  strline4,#0,#90,#4
 Get_str  dolmsgpw::line3,#0,#30,#26
 Put_str  strline5,#0,#90,#4
 Get_str  dolmsgpw::line4,#0,#40,#26
 Put_str  strline6,#0,#90,#4
 Get_str  dolmsgpw::line5,#0,#50,#26
 Put_str  strline7,#0,#90,#4
 Get_str  dolmsgpw::line6,#0,#60,#26
 Put_str  strline8,#0,#90,#4
 Get_str  dolmsgpw::line7,#0,#70,#26
 Put_str  strline9,#0,#90,#4
 Get_str  dolmsgpw::line8,#0,#80,#26
 move.b   #0,try
 bra      msg

 rts                            ;

; //-----------------------------------------------------------\\ ;
; \\-----------------------------------------------------------// ;
; // second part of the Get_str routine
; // ThanX to Alban Gervaise
; //  params : see the Get_str macro
; //  registers : d0,d4,d5,d6,d7 / a5,(a7) are lost
; // 
; // if try is set to 0 before u call the routine -> * instead of
; // real characters
; //-----------------------------------------------------------\\ ;
; \\-----------------------------------------------------------// ;

take_string:
 jsr      util::idle_loop
 cmp.w    #257,d0
 beq      undo
 cmp.w    #264,d0
 beq      bon
 cmp.w    #13,d0
 beq      bon
 move.b   d0,(a5)+
 move.w   #2,-(a7)
 move.w   d6,-(a7)
 move.w   d5,-(a7)

 cmp.b    #0,try                    ; if try is set to 0 
 beq      stars                     ; put stars
 move.w   d0,-(a7)                  ; else normal character
 bra      end_stars

stars
 move.w   #42,-(a7) 
end_stars
  
 jsr      util::DrawCharXY
 lea      8(a7),a7
 add.w    #6,d5
 dbra     d7,take_string
bon
 cmp.w    d4,d7
 beq      take_string
 clr.b    (a5)
 rts
undo
 cmp.w    d4,d7
 beq      take_string
 add.w    #1,d7
 clr.b    -(a5)
 sub.w    #6,d5
 move.w   #4,-(a7)
 move.w   d6,-(a7)
 move.w   d5,-(a7)
 move.w   #32,-(a7)
 jsr      util::DrawCharXY
 lea      8(a7),a7
 bra      take_string

; //-----------------------------------------------------------\\ ;
; \\-----------------------------------------------------------// ;
; // The Data section
; //-----------------------------------------------------------\\ ;
; \\-----------------------------------------------------------// ;

menu          dc.b "Menu",0
changepwd     dc.b "2. Change the password",0
changemsg     dc.b "1. Configure the message",0
exit          dc.b "3. Exit",0
msgstr        dc.b "Message",0
chmsg         dc.b "2. Change the message",0
ermsg         dc.b "1. Erase the message",0
vimsg         dc.b "3. View the message",0
return        dc.b "4. Return",0
try           dc.b 0 
oldpass       dc.b " Old Pwd :",0
newpass       dc.b " New Pwd :",0
confirm       dc.b " Confirm :",0
notchanged    dc.b "PassWord NOT changed !!",0
changed       dc.b "Pwd changed successfully",0
prompt        dc.b "PassWord :",0
string        dc.b "          ",0                                        ; input
string2       dc.b "          ",0                                        ; to confirm the new password
freeline      dc.b 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; to erase the msg
done          dc.b "Done.",0
strline1      dc.b "Enter line #1",0
strline2      dc.b "Enter line #2",0
strline3      dc.b "Enter line #3",0
strline4      dc.b "Enter line #4",0
strline5      dc.b "Enter line #5",0
strline6      dc.b "Enter line #6",0
strline7      dc.b "Enter line #7",0
strline8      dc.b "Enter line #8",0
strline9      dc.b "Enter line #9",0


 end